<template>
    <div class="auth-wrapper text-center">
        <main class="form-signin">
            <form @submit="onProfileUpdate" class="main-form">
                <img class="mb-4 form-img" src="../assets/images/poke-ball.png" alt="" width="72" height="57">
                <h1 class="h3 mb-3 fw-normal">Be part of an awesome community</h1>

                <div class="form-floating">
                    <input v-model="first_name" type="text" class="form-control" id="fname" required>
                    <label for="floatingInput">First Name</label>
                </div>
                <div class="form-floating">
                    <input v-model="last_name" type="text" class="form-control" id="lname" required>
                    <label for="floatingInput">Last Name</label>
                </div>
                <div class="form-floating">
                    <input v-model="birthdate" type="date" class="form-control" id="bdate" required>
                    <label for="floatingInput">Birthdate</label>
                </div>


                <br>
                <button type="submit" class="mb-2 w-100 btn btn-lg btn-primary btn-form-action">Update</button>
            </form>


            <p class="mt-5 mb-3 text-muted">
                Designed and Developed by <a href="https://gabrielarellano.tech/" target="blank">
                    <img src="https://gabrielarellano.tech/wp-content/uploads/2022/12/default-logo.png"
                        class="footer-logo">
                </a>
            </p>
        </main>
    </div>
</template>

<script>
export default {
    name: "EditProfileView",
    data() {
        return {
            token: "",
            first_name: "",
            last_name: "",
            birthdate: "",
            email: "",
            password: "",
            password_confirmation: "",
        }
    },
    async created() {
        this.token = localStorage.getItem("pokemon-bearer-token");
        if (!this.token) {
            this.$router.push('/')
        }
        else {
            const res = await fetch('http://localhost:8000/api/user', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json',
                    'Authorization': `Bearer ${this.token}`,
                },
            })
            this.user = await res.json()
            this.first_name = this.user.first_name
            this.last_name = this.user.last_name
            this.birthdate = this.user.birthdate

        }
    },
    methods: {

        async update(credentials) {
           await fetch('http://localhost:8000/api/edit-profile', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json',
                    'Authorization': `Bearer ${this.token}`,

                },
                body: JSON.stringify(credentials)
            })



            this.$router.push('/dashboard')
        },
        onProfileUpdate(e) {
            e.preventDefault();

            const updateAttempt = {
                first_name: this.first_name,
                last_name: this.last_name,
                birthdate: this.birthdate,
            }

            if (this.first_name && this.last_name && this.birthdate) {
                this.update(updateAttempt)
            }
            else {
                alert('Please suffice all data')
            }
        },
    },

}
</script>
